--
-- VHDL Architecture Cosmic0_lib.Flash.Simple
--
-- Created:
--          by - goodrick.UNKNOWN (PCEQ)
--          at - 17:38:44 22/06/2004
--
-- using Mentor Graphics HDL Designer(TM) 2003.2 (Build 28)
--
-- Modernised 2010-09-29
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_unsigned.all;

ENTITY FlashLong IS
   GENERIC( 
      FLCountMax : integer := 20
   );
   PORT( 
      CO : IN     std_logic;
      Ck : IN     std_logic;
      Rst: IN     std_logic;
      FL : OUT    std_logic
   );

-- Declarations

END FlashLong ;

--
ARCHITECTURE Simple OF FlashLong IS
   --signal FLCount : std_logic_vector(5 downto 0) := "111111" ;
   signal FLCount : integer range 0 to 16000000 ;
BEGIN
   process(Ck,CO,Rst)
   begin
     if (Rst = '1') then
       FLCount <= FLCountMax ;
     elsif(CO = '1') then
       FLCount <= 0 ;
     elsif(rising_edge(Ck)) then
       if(FLCount >= FLCountMax) then  -- generic value
         FLCount <= FLCountMax ;
       else
         -- Inc FLCount
         FLCount <= FLCount + 1 ;            
       end if;
     end if ;
     if((FLCount >=0) and (FLCount < (FLCountMax/2))) then
       FL <= '1';
     else
       FL <= '0';
     end if;
   end process;
END Simple;

