-- module: div_22.vhd

-- This module divides the incoming clock by 2^22 and outputs the 
-- 22th bit of the counter as clk_2k.

library IEEE;
use IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;

use ieee.numeric_std.all;

ENTITY div_22 IS
   GENERIC( 
      div : integer := 22
   );
   PORT( 
      clk     : IN     STD_LOGIC;
      clk_2k2 : OUT    STD_LOGIC
   );

-- Declarations

END div_22 ;

architecture div_22_arch of div_22 is

    signal count : STD_LOGIC_VECTOR(24 downto 0):= "0000000000000000000000000";
    
begin

    process(clk)
    begin

        if(clk'event and clk='1') then  
            count<=count + 1;
        end if;

    end process;
    
    clk_2k2<=count(div);
    
end div_22_arch;

