-- VHDL Entity Cosmix_lib.SpHitBlock.symbol
--
-- Created:
--          by - Matthew.UNKNOWN (PCJL)
--          at - 10:21:41 26/07/2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2010.3 (Build 21)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY SpHitBlock IS
   PORT( 
      clk       : IN     std_logic;
      pulse     : IN     std_logic;
      hit       : OUT    std_logic;
      fl        : OUT    std_logic;
      clk_fl    : IN     std_logic;
      reset     : IN     std_logic;
      out_width : IN     std_logic_vector (3 DOWNTO 0)
   );

-- Declarations

END SpHitBlock ;

--
-- VHDL Architecture Cosmix_lib.SpHitBlock.struct
--
-- Created:
--          by - Matthew.UNKNOWN (PCJL)
--          at - 10:21:41 26/07/2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2010.3 (Build 21)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;

LIBRARY Cosmix_lib;

ARCHITECTURE struct OF SpHitBlock IS

   -- Architecture declarations

   -- Internal signal declarations

   -- Implicit buffer signal declarations
   SIGNAL hit_internal : std_logic;


   -- Component Declarations
   COMPONENT Flash
   GENERIC (
      FLCountMax : integer := 20
   );
   PORT (
      CO  : IN     std_logic ;
      Ck  : IN     std_logic ;
      FL  : OUT    std_logic ;
      Rst : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT hit_stretch
   PORT (
      clk       : IN     std_logic;
      out_width : IN     std_logic_vector (3 DOWNTO 0);
      pulse     : IN     std_logic;
      reset     : IN     std_logic;
      hit       : OUT    std_logic
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : Flash USE ENTITY Cosmix_lib.Flash;
   FOR ALL : hit_stretch USE ENTITY Cosmix_lib.hit_stretch;
   -- pragma synthesis_on


BEGIN

   -- Instance port mappings.
   I1 : Flash
      GENERIC MAP (
         FLCountMax => 20
      )
      PORT MAP (
         CO  => hit_internal,
         Ck  => clk_fl,
         FL  => fl,
         Rst => reset
      );
   I2 : hit_stretch
      PORT MAP (
         clk       => clk,
         reset     => reset,
         pulse     => pulse,
         out_width => out_width,
         hit       => hit_internal
      );

   -- Implicit buffered output assignments
   hit <= hit_internal;

END struct;
