## SETUP
puts "Info: HDL Designer Synthesis run started"

## Set current project and folder
if {[string length [info commands new_project]]} {
   open_project "z:/HDL/Cosmix/Cosmix_lib/ps/TopSpark_struct/TopSpark_struct.psp"
   new_impl
} else {
   set_working_dir "z:/HDL/Cosmix/Cosmix_lib/ps/TopSpark_struct"
}

## Implementation settings
MGS_Gui::notify_gui lock
setup_design -manufacturer "Xilinx" -family "SPARTAN2E" -part "2s100etq144" -speed "6" 

## Design Settings
setup_design -addio=true
setup_design -use_safe_fsm=true
setup_design -retiming=true
if {[catch {setup_design -2004c_compile_mode=false}]} {
catch {setup_design -frontend_2004=false}
}

setup_design -vhdl=false
setup_design -verilog=false
setup_design -edif=true
setup_design -frequency="80"
setup_design -input_delay="5"
setup_design -output_delay="5"

## Read in source files
catch {source "z:/HDL/Cosmix/Cosmix_lib/ps/Cosmixer/hds/add_files.tcl"}
MGS_Gui::notify_gui unlock

## Compile & Synthesize
MGS_Gui::notify_gui lock
if {[catch compile]} {
   MGS_Gui::notify_gui unlock
} elseif {[catch synthesize]} {
   MGS_Gui::notify_gui unlock
} else {
   MGS_Gui::notify_gui unlock
}

puts "Info: HDL Designer Synthesis run finished"


