--------------------------------------------------------------------------------
-- Copyright (c) 1995-2011 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 13.2
--  \   \         Application : sch2hdl
--  /   /         Filename : CROCS.vhf
-- /___/   /\     Timestamp : 08/09/2012 09:43:02
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan6 -flat -suppress -vhdl Q:/users/matthew/HDL/CosmixGPS/CosmixGPS/CROCS.vhf -w Q:/users/matthew/HDL/CosmixGPS/CosmixGPS/CROCS.sch
--Design Name: CROCS
--Device: spartan6
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--
----- CELL CB4CE_HXILINX_CROCS -----


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity CB4CE_HXILINX_CROCS is
  
port (
    CEO  : out STD_LOGIC;
    Q0   : out STD_LOGIC;
    Q1   : out STD_LOGIC;
    Q2   : out STD_LOGIC;
    Q3   : out STD_LOGIC;
    TC   : out STD_LOGIC;
    C    : in STD_LOGIC;
    CE   : in STD_LOGIC;
    CLR  : in STD_LOGIC
    );
end CB4CE_HXILINX_CROCS;

architecture Behavioral of CB4CE_HXILINX_CROCS is

  signal COUNT : STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
  constant TERMINAL_COUNT : STD_LOGIC_VECTOR(3 downto 0) := (others => '1');
  
begin

process(C, CLR)
begin
  if (CLR='1') then
    COUNT <= (others => '0');
  elsif (C'event and C = '1') then
    if (CE='1') then 
      COUNT <= COUNT+1;
    end if;
  end if;
end process;

TC   <=  '0' when (CLR = '1') else
         '1' when (COUNT = TERMINAL_COUNT) else '0';
CEO  <= '1' when ((COUNT = TERMINAL_COUNT) and CE='1') else '0';

Q3 <= COUNT(3);
Q2 <= COUNT(2);
Q1 <= COUNT(1);
Q0 <= COUNT(0);

end Behavioral;

----- CELL CB16CE_HXILINX_CROCS -----


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity CB16CE_HXILINX_CROCS is
port (
    CEO : out STD_LOGIC;
    Q   : out STD_LOGIC_VECTOR(15 downto 0);
    TC  : out STD_LOGIC;
    C   : in STD_LOGIC;
    CE  : in STD_LOGIC;
    CLR : in STD_LOGIC
    );
end CB16CE_HXILINX_CROCS;

architecture Behavioral of CB16CE_HXILINX_CROCS is

  signal COUNT : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
  constant TERMINAL_COUNT : STD_LOGIC_VECTOR(15 downto 0) := (others => '1');
  
begin

process(C, CLR)
begin
  if (CLR='1') then
    COUNT <= (others => '0');
  elsif (C'event and C = '1') then
    if (CE='1') then 
      COUNT <= COUNT+1;
    end if;
  end if;
end process;

TC  <=  '0' when (CLR = '1') else
        '1' when (COUNT = TERMINAL_COUNT) else '0';
CEO <= '1' when ((COUNT = TERMINAL_COUNT) and CE='1') else '0';
Q   <= COUNT;

end Behavioral;

----- CELL M16_1E_HXILINX_CROCS -----
  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity M16_1E_HXILINX_CROCS is
  
port(
    O    : out std_logic;

    D0   : in std_logic;
    D1   : in std_logic;
    D2   : in std_logic;
    D3   : in std_logic;
    D4   : in std_logic;
    D5   : in std_logic;
    D6   : in std_logic;
    D7   : in std_logic;
    D8   : in std_logic;
    D9   : in std_logic;
    D10  : in std_logic;
    D11  : in std_logic;
    D12  : in std_logic;
    D13  : in std_logic;
    D14  : in std_logic;
    D15  : in std_logic;
    E    : in std_logic;
    S0   : in std_logic;
    S1   : in std_logic;
    S2   : in std_logic;
    S3   : in std_logic
  );
end M16_1E_HXILINX_CROCS;

architecture M16_1E_HXILINX_CROCS_V of M16_1E_HXILINX_CROCS is
begin
  process (D0, D1, D2, D3, D4, D5, D6, D7, D8, D9, D10, D11, D12, D13, D14, D15, E, S0, S1, S2, S3)
  variable sel : std_logic_vector(3 downto 0);
  begin
    sel := S3&S2&S1&S0;
    if( E = '0') then
    O <= '0';
    else
      case sel is
      when "0000" => O <= D0;
      when "0001" => O <= D1;
      when "0010" => O <= D2;
      when "0011" => O <= D3;
      when "0100" => O <= D4;
      when "0101" => O <= D5;
      when "0110" => O <= D6;
      when "0111" => O <= D7;
      when "1000" => O <= D8;
      when "1001" => O <= D9;
      when "1010" => O <= D10;
      when "1011" => O <= D11;
      when "1100" => O <= D12;
      when "1101" => O <= D13;
      when "1110" => O <= D14;
      when "1111" => O <= D15;
      when others => NULL;
      end case;
    end if;
    end process; 
end M16_1E_HXILINX_CROCS_V;

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity UARTDriver_MUSER_CROCS is
   port ( clk       : in    std_logic; 
          dataIn    : in    std_logic_vector (7 downto 0); 
          dataReady : in    std_logic; 
          serialOut : out   std_logic);
end UARTDriver_MUSER_CROCS;

architecture BEHAVIORAL of UARTDriver_MUSER_CROCS is
   attribute HU_SET     : string ;
   attribute BOX_TYPE   : string ;
   signal XLXN_44               : std_logic;
   signal XLXN_47               : std_logic;
   signal XLXN_48               : std_logic;
   signal XLXN_52               : std_logic;
   signal XLXN_53               : std_logic;
   signal XLXN_55               : std_logic;
   signal XLXN_62               : std_logic;
   signal XLXI_6_D10_openSignal : std_logic;
   signal XLXI_6_D11_openSignal : std_logic;
   signal XLXI_6_D12_openSignal : std_logic;
   signal XLXI_6_D13_openSignal : std_logic;
   signal XLXI_6_D14_openSignal : std_logic;
   signal XLXI_6_D15_openSignal : std_logic;
   component CB4CE_HXILINX_CROCS
      port ( C   : in    std_logic; 
             CE  : in    std_logic; 
             CLR : in    std_logic; 
             CEO : out   std_logic; 
             Q0  : out   std_logic; 
             Q1  : out   std_logic; 
             Q2  : out   std_logic; 
             Q3  : out   std_logic; 
             TC  : out   std_logic);
   end component;
   
   component M16_1E_HXILINX_CROCS
      port ( D0  : in    std_logic; 
             D1  : in    std_logic; 
             D10 : in    std_logic; 
             D11 : in    std_logic; 
             D12 : in    std_logic; 
             D13 : in    std_logic; 
             D14 : in    std_logic; 
             D15 : in    std_logic; 
             D2  : in    std_logic; 
             D3  : in    std_logic; 
             D4  : in    std_logic; 
             D5  : in    std_logic; 
             D6  : in    std_logic; 
             D7  : in    std_logic; 
             D8  : in    std_logic; 
             D9  : in    std_logic; 
             E   : in    std_logic; 
             S0  : in    std_logic; 
             S1  : in    std_logic; 
             S2  : in    std_logic; 
             S3  : in    std_logic; 
             O   : out   std_logic);
   end component;
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   component NAND4B2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND4B2 : component is "BLACK_BOX";
   
   attribute HU_SET of UART_COUNTER : label is "UART_COUNTER_0";
   attribute HU_SET of XLXI_6 : label is "XLXI_6_1";
begin
   UART_COUNTER : CB4CE_HXILINX_CROCS
      port map (C=>clk,
                CE=>XLXN_55,
                CLR=>dataReady,
                CEO=>open,
                Q0=>XLXN_47,
                Q1=>XLXN_52,
                Q2=>XLXN_48,
                Q3=>XLXN_53,
                TC=>open);
   
   XLXI_6 : M16_1E_HXILINX_CROCS
      port map (D0=>XLXN_44,
                D1=>dataIn(0),
                D2=>dataIn(1),
                D3=>dataIn(2),
                D4=>dataIn(3),
                D5=>dataIn(4),
                D6=>dataIn(5),
                D7=>dataIn(6),
                D8=>dataIn(7),
                D9=>XLXN_62,
                D10=>XLXI_6_D10_openSignal,
                D11=>XLXI_6_D11_openSignal,
                D12=>XLXI_6_D12_openSignal,
                D13=>XLXI_6_D13_openSignal,
                D14=>XLXI_6_D14_openSignal,
                D15=>XLXI_6_D15_openSignal,
                E=>XLXN_62,
                S0=>XLXN_47,
                S1=>XLXN_52,
                S2=>XLXN_48,
                S3=>XLXN_53,
                O=>serialOut);
   
   XLXI_7 : GND
      port map (G=>XLXN_44);
   
   XLXI_8 : VCC
      port map (P=>XLXN_62);
   
   XLXI_12 : NAND4B2
      port map (I0=>XLXN_48,
                I1=>XLXN_47,
                I2=>XLXN_53,
                I3=>XLXN_52,
                O=>XLXN_55);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity CommandDetector_MUSER_CROCS is
   port ( data      : in    std_logic_vector (7 downto 0); 
          dataReady : in    std_logic; 
          newCom    : out   std_logic; 
          newData   : out   std_logic);
end CommandDetector_MUSER_CROCS;

architecture BEHAVIORAL of CommandDetector_MUSER_CROCS is
   attribute BOX_TYPE   : string ;
   signal comEnable   : std_logic;
   signal newDataRaw  : std_logic;
   signal NEW_COM_RAW : std_logic;
   signal XLXN_115    : std_logic;
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component NOR5
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NOR5 : component is "BLACK_BOX";
   
   component AND5
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND5 : component is "BLACK_BOX";
   
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
begin
   XLXI_25 : FD
      port map (C=>comEnable,
                D=>newDataRaw,
                Q=>NEW_COM_RAW);
   
   XLXI_26 : INV
      port map (I=>NEW_COM_RAW,
                O=>newDataRaw);
   
   XLXI_39 : NOR5
      port map (I0=>data(2),
                I1=>data(3),
                I2=>data(4),
                I3=>data(6),
                I4=>data(7),
                O=>XLXN_115);
   
   XLXI_44 : AND5
      port map (I0=>dataReady,
                I1=>data(0),
                I2=>data(1),
                I3=>data(5),
                I4=>XLXN_115,
                O=>comEnable);
   
   XLXI_56 : AND2
      port map (I0=>comEnable,
                I1=>newDataRaw,
                O=>newData);
   
   XLXI_57 : AND2
      port map (I0=>comEnable,
                I1=>NEW_COM_RAW,
                O=>newCom);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity UARTDataReadout_MUSER_CROCS is
   port ( clk       : in    std_logic; 
          clk4x     : in    std_logic; 
          dataIn    : in    std_logic_vector (7 downto 0); 
          dataReady : in    std_logic; 
          rst       : in    std_logic; 
          serRxd    : in    std_logic; 
          dataOut   : out   std_logic_vector (7 downto 0); 
          newCom    : out   std_logic; 
          newData   : out   std_logic; 
          serTxd    : out   std_logic);
end UARTDataReadout_MUSER_CROCS;

architecture BEHAVIORAL of UARTDataReadout_MUSER_CROCS is
   signal XLXN_14       : std_logic;
   signal dataOut_DUMMY : std_logic_vector (7 downto 0);
   component CommandDetector_MUSER_CROCS
      port ( data      : in    std_logic_vector (7 downto 0); 
             dataReady : in    std_logic; 
             newData   : out   std_logic; 
             newCom    : out   std_logic);
   end component;
   
   component DataSynchroniser
      port ( serialIn : in    std_logic; 
             clk4x    : in    std_logic; 
             rst      : in    std_logic; 
             newData  : out   std_logic; 
             dataOut  : out   std_logic_vector (7 downto 0));
   end component;
   
   component UARTDriver_MUSER_CROCS
      port ( clk       : in    std_logic; 
             dataIn    : in    std_logic_vector (7 downto 0); 
             dataReady : in    std_logic; 
             serialOut : out   std_logic);
   end component;
   
begin
   dataOut(7 downto 0) <= dataOut_DUMMY(7 downto 0);
   UART_CMD_DET : CommandDetector_MUSER_CROCS
      port map (data(7 downto 0)=>dataOut_DUMMY(7 downto 0),
                dataReady=>XLXN_14,
                newCom=>newCom,
                newData=>newData);
   
   UART_DATA_SYNC : DataSynchroniser
      port map (clk4x=>clk4x,
                rst=>rst,
                serialIn=>serRxd,
                dataOut(7 downto 0)=>dataOut_DUMMY(7 downto 0),
                newData=>XLXN_14);
   
   XLXI_1 : UARTDriver_MUSER_CROCS
      port map (clk=>clk,
                dataIn(7 downto 0)=>dataIn(7 downto 0),
                dataReady=>dataReady,
                serialOut=>serTxd);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity GPS_MUSER_CROCS is
   port ( addr    : in    std_logic_vector (15 downto 0); 
          clk     : in    std_logic; 
          gpsPps  : in    std_logic; 
          gpsTxd  : in    std_logic; 
          hit     : in    std_logic_vector (3 downto 0); 
          rst     : in    std_logic; 
          data    : out   std_logic_vector (7 downto 0); 
          newData : out   std_logic);
end GPS_MUSER_CROCS;

architecture BEHAVIORAL of GPS_MUSER_CROCS is
   signal XLXN_76  : std_logic_vector (7 downto 0);
   signal XLXN_99  : std_logic;
   signal XLXN_128 : std_logic;
   signal XLXN_141 : std_logic_vector (7 downto 0);
   signal XLXN_142 : std_logic_vector (7 downto 0);
   component NMEA183Decode
      port ( dataReady : in    std_logic; 
             clk       : in    std_logic; 
             rst       : in    std_logic; 
             data      : in    std_logic_vector (7 downto 0); 
             msgData   : out   std_logic_vector (7 downto 0); 
             msgAddr   : in    std_logic_vector (7 downto 0); 
             msgValid  : out   std_logic);
   end component;
   
   component AsyncSerialRX
      generic( BaudRate : integer :=  9600);
      port ( serialIn : in    std_logic; 
             clk      : in    std_logic; 
             rst      : in    std_logic; 
             newData  : out   std_logic; 
             dataOut  : out   std_logic_vector (7 downto 0));
   end component;
   
   component GPSTime
      port ( nmeaMsgValid : in    std_logic; 
             nmeaMsgData  : in    std_logic_vector (7 downto 0); 
             nmeaMsgAddr  : out   std_logic_vector (7 downto 0); 
             newData      : out   std_logic; 
             data         : out   std_logic_vector (7 downto 0); 
             addr         : in    std_logic_vector (15 downto 0); 
             hit          : in    std_logic_vector (3 downto 0); 
             PPS          : in    std_logic; 
             clk          : in    std_logic; 
             rst          : in    std_logic);
   end component;
   
begin
   GPS_DECODE : NMEA183Decode
      port map (clk=>clk,
                data(7 downto 0)=>XLXN_76(7 downto 0),
                dataReady=>XLXN_99,
                msgAddr(7 downto 0)=>XLXN_142(7 downto 0),
                rst=>rst,
                msgData(7 downto 0)=>XLXN_141(7 downto 0),
                msgValid=>XLXN_128);
   
   GPS_SERIAL_RX : AsyncSerialRX
   generic map( BaudRate => 9600)
      port map (clk=>clk,
                rst=>rst,
                serialIn=>gpsTxd,
                dataOut(7 downto 0)=>XLXN_76(7 downto 0),
                newData=>XLXN_99);
   
   GPS_TIME : GPSTime
      port map (addr(15 downto 0)=>addr(15 downto 0),
                clk=>rst,
                hit(3 downto 0)=>hit(3 downto 0),
                nmeaMsgData(7 downto 0)=>XLXN_141(7 downto 0),
                nmeaMsgValid=>XLXN_128,
                PPS=>gpsPps,
                rst=>clk,
                data(7 downto 0)=>data(7 downto 0),
                newData=>newData,
                nmeaMsgAddr(7 downto 0)=>XLXN_142(7 downto 0));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity CROCS is
   port ( GCLK    : in    std_logic; 
          JB0     : in    std_logic; 
          JB1     : in    std_logic; 
          JB2     : in    std_logic; 
          JB3     : in    std_logic; 
          JC2     : in    std_logic; 
          JC6     : in    std_logic; 
          SER_RXD : in    std_logic; 
          JD0     : out   std_logic; 
          JD1     : out   std_logic; 
          JD2     : out   std_logic; 
          JD3     : out   std_logic; 
          JD4     : out   std_logic; 
          JD5     : out   std_logic; 
          JD6     : out   std_logic; 
          JD7     : out   std_logic; 
          LED0    : out   std_logic; 
          LED1    : out   std_logic; 
          LED2    : out   std_logic; 
          LED3    : out   std_logic; 
          LED4    : out   std_logic; 
          LED5    : out   std_logic; 
          LED6    : out   std_logic; 
          LED7    : out   std_logic; 
          SER_TXD : out   std_logic);
end CROCS;

architecture BEHAVIORAL of CROCS is
   attribute IOSTANDARD            : string ;
   attribute SLEW                  : string ;
   attribute DRIVE                 : string ;
   attribute BOX_TYPE              : string ;
   attribute CLK_FEEDBACK          : string ;
   attribute CLKDV_DIVIDE          : string ;
   attribute CLKFX_DIVIDE          : string ;
   attribute CLKIN_PERIOD          : string ;
   attribute CLKFX_MULTIPLY        : string ;
   attribute CLKIN_DIVIDE_BY_2     : string ;
   attribute CLKOUT_PHASE_SHIFT    : string ;
   attribute DESKEW_ADJUST         : string ;
   attribute DFS_FREQUENCY_MODE    : string ;
   attribute DLL_FREQUENCY_MODE    : string ;
   attribute DSS_MODE              : string ;
   attribute DUTY_CYCLE_CORRECTION : string ;
   attribute PHASE_SHIFT           : string ;
   attribute STARTUP_WAIT          : string ;
   attribute FACTORY_JF            : string ;
   attribute IBUF_DELAY_VALUE      : string ;
   attribute IFD_DELAY_VALUE       : string ;
   attribute HU_SET                : string ;
   signal CLK                               : std_logic;
   signal CLK_BUS                           : std_logic_vector (15 downto 0);
   signal CLK76M                            : std_logic;
   signal GPS_PPS                           : std_logic;
   signal GPS_PPS_LONG                      : std_logic;
   signal GPS_TXD                           : std_logic;
   signal HIT                               : std_logic_vector (3 downto 0);
   signal RST                               : std_logic;
   signal XLXN_618                          : std_logic;
   signal XLXN_619                          : std_logic;
   signal XLXN_824                          : std_logic_vector (7 downto 0);
   signal XLXN_825                          : std_logic;
   signal XLXN_835                          : std_logic;
   signal XLXN_836                          : std_logic;
   signal BUFFER_LED1_I_openSignal          : std_logic;
   signal BUFFER_LED2_I_openSignal          : std_logic;
   signal BUFFER_LED3_I_openSignal          : std_logic;
   signal BUFFER_LED4_I_openSignal          : std_logic;
   signal BUFFER_LED5_I_openSignal          : std_logic;
   signal BUFFER_LED6_I_openSignal          : std_logic;
   signal BUFFER_LED7_I_openSignal          : std_logic;
   signal BUFFER_TEST3_I_openSignal         : std_logic;
   signal BUFFER_TEST4_I_openSignal         : std_logic;
   signal BUFFER_TEST5_I_openSignal         : std_logic;
   signal BUFFER_TEST6_I_openSignal         : std_logic;
   signal BUFFER_TEST7_I_openSignal         : std_logic;
   signal CLOCK_MANAGER_DSSEN_openSignal    : std_logic;
   signal CLOCK_MANAGER_PSCLK_openSignal    : std_logic;
   signal CLOCK_MANAGER_PSEN_openSignal     : std_logic;
   signal CLOCK_MANAGER_PSINCDEC_openSignal : std_logic;
   signal GPS_MODULE_addr_openSignal        : std_logic_vector (15 downto 0);
   signal XLXI_258_I_openSignal             : std_logic;
   component OBUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute IOSTANDARD of OBUF : component is "DEFAULT";
   attribute SLEW of OBUF : component is "SLOW";
   attribute DRIVE of OBUF : component is "12";
   attribute BOX_TYPE of OBUF : component is "BLACK_BOX";
   
   component DCM_SP
      -- synopsys translate_off
      generic( CLK_FEEDBACK : string :=  "1X";
               CLKDV_DIVIDE : real :=  2.0;
               CLKFX_DIVIDE : integer :=  1;
               CLKIN_PERIOD : real :=  10.0;
               CLKFX_MULTIPLY : integer :=  4;
               CLKIN_DIVIDE_BY_2 : boolean :=  FALSE;
               CLKOUT_PHASE_SHIFT : string :=  "NONE";
               DESKEW_ADJUST : string :=  "SYSTEM_SYNCHRONOUS";
               DFS_FREQUENCY_MODE : string :=  "LOW";
               DLL_FREQUENCY_MODE : string :=  "LOW";
               DSS_MODE : string :=  "NONE";
               DUTY_CYCLE_CORRECTION : boolean :=  TRUE;
               PHASE_SHIFT : integer :=  0;
               STARTUP_WAIT : boolean :=  FALSE;
               FACTORY_JF : bit_vector :=  x"C080");
      -- synopsys translate_on
      port ( CLKFB    : in    std_logic; 
             CLKIN    : in    std_logic; 
             DSSEN    : in    std_logic; 
             PSCLK    : in    std_logic; 
             PSEN     : in    std_logic; 
             PSINCDEC : in    std_logic; 
             RST      : in    std_logic; 
             CLK0     : out   std_logic; 
             CLK180   : out   std_logic; 
             CLK270   : out   std_logic; 
             CLK2X    : out   std_logic; 
             CLK2X180 : out   std_logic; 
             CLK90    : out   std_logic; 
             CLKDV    : out   std_logic; 
             CLKFX    : out   std_logic; 
             CLKFX180 : out   std_logic; 
             LOCKED   : out   std_logic; 
             PSDONE   : out   std_logic; 
             STATUS   : out   std_logic_vector (7 downto 0));
   end component;
   attribute CLK_FEEDBACK of DCM_SP : component is "1X";
   attribute CLKDV_DIVIDE of DCM_SP : component is "2.0";
   attribute CLKFX_DIVIDE of DCM_SP : component is "1";
   attribute CLKIN_PERIOD of DCM_SP : component is "10.0";
   attribute CLKFX_MULTIPLY of DCM_SP : component is "4";
   attribute CLKIN_DIVIDE_BY_2 of DCM_SP : component is "FALSE";
   attribute CLKOUT_PHASE_SHIFT of DCM_SP : component is "NONE";
   attribute DESKEW_ADJUST of DCM_SP : component is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DLL_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DSS_MODE of DCM_SP : component is "NONE";
   attribute DUTY_CYCLE_CORRECTION of DCM_SP : component is "TRUE";
   attribute PHASE_SHIFT of DCM_SP : component is "0";
   attribute STARTUP_WAIT of DCM_SP : component is "FALSE";
   attribute FACTORY_JF of DCM_SP : component is "C080";
   attribute BOX_TYPE of DCM_SP : component is "BLACK_BOX";
   
   component GPS_MUSER_CROCS
      port ( hit     : in    std_logic_vector (3 downto 0); 
             newData : out   std_logic; 
             gpsPps  : in    std_logic; 
             clk     : in    std_logic; 
             gpsTxd  : in    std_logic; 
             rst     : in    std_logic; 
             data    : out   std_logic_vector (7 downto 0); 
             addr    : in    std_logic_vector (15 downto 0));
   end component;
   
   component PulseStretcher
      generic( Divisor : integer :=  23);
      port ( pulseIn  : in    std_logic; 
             clk      : in    std_logic; 
             rst      : in    std_logic; 
             pulseOut : out   std_logic);
   end component;
   
   component IBUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute IOSTANDARD of IBUF : component is "DEFAULT";
   attribute IBUF_DELAY_VALUE of IBUF : component is "0";
   attribute IFD_DELAY_VALUE of IBUF : component is "AUTO";
   attribute BOX_TYPE of IBUF : component is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component CB16CE_HXILINX_CROCS
      port ( C   : in    std_logic; 
             CE  : in    std_logic; 
             CLR : in    std_logic; 
             CEO : out   std_logic; 
             Q   : out   std_logic_vector (15 downto 0); 
             TC  : out   std_logic);
   end component;
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   component UARTDataReadout_MUSER_CROCS
      port ( dataReady : in    std_logic; 
             dataIn    : in    std_logic_vector (7 downto 0); 
             dataOut   : out   std_logic_vector (7 downto 0); 
             clk       : in    std_logic; 
             clk4x     : in    std_logic; 
             rst       : in    std_logic; 
             newData   : out   std_logic; 
             newCom    : out   std_logic; 
             serTxd    : out   std_logic; 
             serRxd    : in    std_logic);
   end component;
   
   attribute CLKFX_MULTIPLY of CLOCK_MANAGER : label is "19";
   attribute CLKFX_DIVIDE of CLOCK_MANAGER : label is "25";
   attribute HU_SET of XLXI_274 : label is "XLXI_274_2";
begin
   BUFFER_LED0 : OBUF
      port map (I=>GPS_PPS_LONG,
                O=>LED0);
   
   BUFFER_LED1 : OBUF
      port map (I=>BUFFER_LED1_I_openSignal,
                O=>LED1);
   
   BUFFER_LED2 : OBUF
      port map (I=>BUFFER_LED2_I_openSignal,
                O=>LED2);
   
   BUFFER_LED3 : OBUF
      port map (I=>BUFFER_LED3_I_openSignal,
                O=>LED3);
   
   BUFFER_LED4 : OBUF
      port map (I=>BUFFER_LED4_I_openSignal,
                O=>LED4);
   
   BUFFER_LED5 : OBUF
      port map (I=>BUFFER_LED5_I_openSignal,
                O=>LED5);
   
   BUFFER_LED6 : OBUF
      port map (I=>BUFFER_LED6_I_openSignal,
                O=>LED6);
   
   BUFFER_LED7 : OBUF
      port map (I=>BUFFER_LED7_I_openSignal,
                O=>LED7);
   
   BUFFER_TEST1 : OBUF
      port map (I=>XLXN_835,
                O=>JD0);
   
   BUFFER_TEST2 : OBUF
      port map (I=>XLXN_836,
                O=>JD1);
   
   BUFFER_TEST3 : OBUF
      port map (I=>BUFFER_TEST3_I_openSignal,
                O=>JD2);
   
   BUFFER_TEST4 : OBUF
      port map (I=>BUFFER_TEST4_I_openSignal,
                O=>JD3);
   
   BUFFER_TEST5 : OBUF
      port map (I=>BUFFER_TEST5_I_openSignal,
                O=>JD5);
   
   BUFFER_TEST6 : OBUF
      port map (I=>BUFFER_TEST6_I_openSignal,
                O=>JD6);
   
   BUFFER_TEST7 : OBUF
      port map (I=>BUFFER_TEST7_I_openSignal,
                O=>JD7);
   
   CLOCK_MANAGER : DCM_SP
   -- synopsys translate_off
   generic map( CLKFX_MULTIPLY => 19,
            CLKFX_DIVIDE => 25)
   -- synopsys translate_on
      port map (CLKFB=>CLK,
                CLKIN=>GCLK,
                DSSEN=>CLOCK_MANAGER_DSSEN_openSignal,
                PSCLK=>CLOCK_MANAGER_PSCLK_openSignal,
                PSEN=>CLOCK_MANAGER_PSEN_openSignal,
                PSINCDEC=>CLOCK_MANAGER_PSINCDEC_openSignal,
                RST=>RST,
                CLKDV=>open,
                CLKFX=>CLK76M,
                CLKFX180=>open,
                CLK0=>CLK,
                CLK2X=>open,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>open,
                CLK270=>open,
                LOCKED=>open,
                PSDONE=>open,
                STATUS=>open);
   
   GPS_MODULE : GPS_MUSER_CROCS
      port map (addr(15 downto 0)=>GPS_MODULE_addr_openSignal(15 downto 0),
                clk=>RST,
                gpsPps=>GPS_PPS,
                gpsTxd=>GPS_TXD,
                hit(3 downto 0)=>HIT(3 downto 0),
                rst=>CLK,
                data(7 downto 0)=>XLXN_824(7 downto 0),
                newData=>XLXN_825);
   
   PPS_STRETCHER : PulseStretcher
   generic map( Divisor => 23)
      port map (clk=>CLK,
                pulseIn=>GPS_PPS,
                rst=>RST,
                pulseOut=>GPS_PPS_LONG);
   
   XLXI_47 : IBUF
      port map (I=>JC6,
                O=>GPS_TXD);
   
   XLXI_48 : IBUF
      port map (I=>JC2,
                O=>GPS_PPS);
   
   XLXI_82 : GND
      port map (G=>RST);
   
   XLXI_258 : OBUF
      port map (I=>XLXI_258_I_openSignal,
                O=>JD4);
   
   XLXI_274 : CB16CE_HXILINX_CROCS
      port map (C=>CLK76M,
                CE=>XLXN_618,
                CLR=>XLXN_619,
                CEO=>open,
                Q(15 downto 0)=>CLK_BUS(15 downto 0),
                TC=>open);
   
   XLXI_275 : VCC
      port map (P=>XLXN_618);
   
   XLXI_276 : GND
      port map (G=>XLXN_619);
   
   XLXI_338 : IBUF
      port map (I=>JB0,
                O=>HIT(0));
   
   XLXI_339 : IBUF
      port map (I=>JB1,
                O=>HIT(1));
   
   XLXI_340 : IBUF
      port map (I=>JB2,
                O=>HIT(2));
   
   XLXI_341 : IBUF
      port map (I=>JB3,
                O=>HIT(3));
   
   XLXI_372 : UARTDataReadout_MUSER_CROCS
      port map (clk=>CLK_BUS(11),
                clk4x=>CLK_BUS(9),
                dataIn(7 downto 0)=>XLXN_824(7 downto 0),
                dataReady=>XLXN_825,
                rst=>RST,
                serRxd=>XLXN_836,
                dataOut=>open,
                newCom=>open,
                newData=>open,
                serTxd=>XLXN_835);
   
   XLXI_374 : OBUF
      port map (I=>XLXN_835,
                O=>SER_TXD);
   
   XLXI_377 : IBUF
      port map (I=>SER_RXD,
                O=>XLXN_836);
   
end BEHAVIORAL;


