--------------------------------------------------------------------------------
-- Copyright (c) 1995-2011 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 13.2
--  \   \         Application : sch2hdl
--  /   /         Filename : CommandDetector.vhf
-- /___/   /\     Timestamp : 08/09/2012 09:08:44
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan6 -flat -suppress -vhdl Q:/users/matthew/HDL/CosmixGPS/CosmixGPS/CommandDetector.vhf -w Q:/users/matthew/HDL/CosmixGPS/CosmixGPS/CommandDetector.sch
--Design Name: CommandDetector
--Device: spartan6
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity CommandDetector is
   port ( data      : in    std_logic_vector (7 downto 0); 
          dataReady : in    std_logic; 
          newCom    : out   std_logic; 
          newData   : out   std_logic);
end CommandDetector;

architecture BEHAVIORAL of CommandDetector is
   attribute BOX_TYPE   : string ;
   signal comEnable   : std_logic;
   signal newDataRaw  : std_logic;
   signal NEW_COM_RAW : std_logic;
   signal XLXN_115    : std_logic;
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component NOR5
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NOR5 : component is "BLACK_BOX";
   
   component AND5
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND5 : component is "BLACK_BOX";
   
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
begin
   XLXI_25 : FD
      port map (C=>comEnable,
                D=>newDataRaw,
                Q=>NEW_COM_RAW);
   
   XLXI_26 : INV
      port map (I=>NEW_COM_RAW,
                O=>newDataRaw);
   
   XLXI_39 : NOR5
      port map (I0=>data(2),
                I1=>data(3),
                I2=>data(4),
                I3=>data(6),
                I4=>data(7),
                O=>XLXN_115);
   
   XLXI_44 : AND5
      port map (I0=>dataReady,
                I1=>data(0),
                I2=>data(1),
                I3=>data(5),
                I4=>XLXN_115,
                O=>comEnable);
   
   XLXI_56 : AND2
      port map (I0=>comEnable,
                I1=>newDataRaw,
                O=>newData);
   
   XLXI_57 : AND2
      port map (I0=>comEnable,
                I1=>NEW_COM_RAW,
                O=>newCom);
   
end BEHAVIORAL;


