--------------------------------------------------------------------------------
-- Copyright (c) 1995-2011 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 13.2
--  \   \         Application : sch2hdl
--  /   /         Filename : GPS.vhf
-- /___/   /\     Timestamp : 08/09/2012 09:08:48
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan6 -flat -suppress -vhdl Q:/users/matthew/HDL/CosmixGPS/CosmixGPS/GPS.vhf -w Q:/users/matthew/HDL/CosmixGPS/CosmixGPS/GPS.sch
--Design Name: GPS
--Device: spartan6
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity GPS is
   port ( addr    : in    std_logic_vector (15 downto 0); 
          clk     : in    std_logic; 
          gpsPps  : in    std_logic; 
          gpsTxd  : in    std_logic; 
          hit     : in    std_logic_vector (3 downto 0); 
          rst     : in    std_logic; 
          data    : out   std_logic_vector (7 downto 0); 
          newData : out   std_logic);
end GPS;

architecture BEHAVIORAL of GPS is
   signal XLXN_76  : std_logic_vector (7 downto 0);
   signal XLXN_99  : std_logic;
   signal XLXN_128 : std_logic;
   signal XLXN_141 : std_logic_vector (7 downto 0);
   signal XLXN_142 : std_logic_vector (7 downto 0);
   component NMEA183Decode
      port ( dataReady : in    std_logic; 
             clk       : in    std_logic; 
             rst       : in    std_logic; 
             data      : in    std_logic_vector (7 downto 0); 
             msgData   : out   std_logic_vector (7 downto 0); 
             msgAddr   : in    std_logic_vector (7 downto 0); 
             msgValid  : out   std_logic);
   end component;
   
   component AsyncSerialRX
      generic( BaudRate : integer :=  9600);
      port ( serialIn : in    std_logic; 
             clk      : in    std_logic; 
             rst      : in    std_logic; 
             newData  : out   std_logic; 
             dataOut  : out   std_logic_vector (7 downto 0));
   end component;
   
   component GPSTime
      port ( nmeaMsgValid : in    std_logic; 
             nmeaMsgData  : in    std_logic_vector (7 downto 0); 
             nmeaMsgAddr  : out   std_logic_vector (7 downto 0); 
             newData      : out   std_logic; 
             data         : out   std_logic_vector (7 downto 0); 
             addr         : in    std_logic_vector (15 downto 0); 
             hit          : in    std_logic_vector (3 downto 0); 
             PPS          : in    std_logic; 
             clk          : in    std_logic; 
             rst          : in    std_logic);
   end component;
   
begin
   GPS_DECODE : NMEA183Decode
      port map (clk=>clk,
                data(7 downto 0)=>XLXN_76(7 downto 0),
                dataReady=>XLXN_99,
                msgAddr(7 downto 0)=>XLXN_142(7 downto 0),
                rst=>rst,
                msgData(7 downto 0)=>XLXN_141(7 downto 0),
                msgValid=>XLXN_128);
   
   GPS_SERIAL_RX : AsyncSerialRX
   generic map( BaudRate => 9600)
      port map (clk=>clk,
                rst=>rst,
                serialIn=>gpsTxd,
                dataOut(7 downto 0)=>XLXN_76(7 downto 0),
                newData=>XLXN_99);
   
   GPS_TIME : GPSTime
      port map (addr(15 downto 0)=>addr(15 downto 0),
                clk=>rst,
                hit(3 downto 0)=>hit(3 downto 0),
                nmeaMsgData(7 downto 0)=>XLXN_141(7 downto 0),
                nmeaMsgValid=>XLXN_128,
                PPS=>gpsPps,
                rst=>clk,
                data(7 downto 0)=>data(7 downto 0),
                newData=>newData,
                nmeaMsgAddr(7 downto 0)=>XLXN_142(7 downto 0));
   
end BEHAVIORAL;


