--------------------------------------------------------------------------------
-- Copyright (c) 1995-2011 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 13.2
--  \   \         Application : sch2hdl
--  /   /         Filename : GPS_drc.vhf
-- /___/   /\     Timestamp : 08/06/2012 14:39:28
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Disk2\Xilinx\13.2\ISE_DS\ISE\bin\nt64\unwrapped\sch2hdl.exe -intstyle ise -family spartan6 -flat -suppress -vhdl GPS_drc.vhf -w Z:/HDL/CosmixGPS/CosmixGPS/GPS.sch
--Design Name: GPS
--Device: spartan6
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity GPS is
   port ( clk         : in    std_logic; 
          gps_pps     : in    std_logic; 
          gps_tx      : in    std_logic; 
          hit         : in    std_logic_vector (3 downto 0); 
          packet_addr : in    std_logic_vector (15 downto 0); 
          reset       : in    std_logic; 
          new_packet  : out   std_logic; 
          packet_data : out   std_logic_vector (7 downto 0));
end GPS;

architecture BEHAVIORAL of GPS is
   signal XLXN_76     : std_logic_vector (7 downto 0);
   signal XLXN_99     : std_logic;
   signal XLXN_110    : std_logic_vector (7 downto 0);
   signal XLXN_111    : std_logic_vector (7 downto 0);
   signal XLXN_128    : std_logic;
   component NMEA183Decode
      port ( data_ready : in    std_logic; 
             reset      : in    std_logic; 
             clk        : in    std_logic; 
             data       : in    std_logic_vector (7 downto 0); 
             msg_addr   : in    std_logic_vector (7 downto 0); 
             msg_valid  : out   std_logic; 
             msg_data   : out   std_logic_vector (7 downto 0));
   end component;
   
   component AsyncSerialRX
      generic( BaudRate : integer :=  9600);
      port ( serial_in  : in    std_logic; 
             clk        : in    std_logic; 
             reset      : in    std_logic; 
             data_ready : out   std_logic; 
             data_out   : out   std_logic_vector (7 downto 0));
   end component;
   
   component GPSTime
      port ( NMEA_msg_valid : in    std_logic; 
             PPS            : in    std_logic; 
             clk            : in    std_logic; 
             reset          : in    std_logic; 
             NMEA_msg_data  : in    std_logic_vector (7 downto 0); 
             hit            : in    std_logic_vector (3 downto 0); 
             addr           : in    std_logic_vector (15 downto 0); 
             new_packet     : out   std_logic; 
             NMEA_msg_addr  : out   std_logic_vector (7 downto 0); 
             data           : out   std_logic_vector (7 downto 0));
   end component;
   
begin
   GPS_DECODE : NMEA183Decode
      port map (clk=>clk,
                data(7 downto 0)=>XLXN_76(7 downto 0),
                data_ready=>XLXN_99,
                msg_addr(7 downto 0)=>XLXN_111(7 downto 0),
                reset=>reset,
                msg_data(7 downto 0)=>XLXN_110(7 downto 0),
                msg_valid=>XLXN_128);
   
   GPS_SERIAL_RX : AsyncSerialRX
   generic map( BaudRate => 9600)
      port map (clk=>clk,
                reset=>reset,
                serial_in=>gps_tx,
                data_out(7 downto 0)=>XLXN_76(7 downto 0),
                data_ready=>XLXN_99);
   
   GPS_TIME : GPSTime
      port map (addr(15 downto 0)=>packet_addr(15 downto 0),
                clk=>clk,
                hit(3 downto 0)=>hit(3 downto 0),
                NMEA_msg_data(7 downto 0)=>XLXN_110(7 downto 0),
                NMEA_msg_valid=>XLXN_128,
                PPS=>gps_pps,
                reset=>reset,
                data(7 downto 0)=>packet_data(7 downto 0),
                new_packet=>new_packet,
                NMEA_msg_addr(7 downto 0)=>XLXN_111(7 downto 0));
   
end BEHAVIORAL;


