-- Vhdl test bench created from schematic Q:\users\fn217\CROCS_firmware\src\CROCS.sch - Fri Jan 28 17:28:39 2011
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;

LIBRARY work;
USE work.Globals.ALL;
USE work.SimHelper.ALL;

ENTITY CROCS_CROCS_sch_tb IS
END CROCS_CROCS_sch_tb;
ARCHITECTURE behavioral OF CROCS_CROCS_sch_tb IS 

   COMPONENT CROCS
   PORT( CLK_XTAL	:	IN	STD_LOGIC; 
          LED_EVENT1	:	OUT	STD_LOGIC; 
          LED_EVENT2	:	OUT	STD_LOGIC; 
          LED_EVENT4	:	OUT	STD_LOGIC; 
          LED_EVENT3	:	OUT	STD_LOGIC; 
          LED_EVENT5	:	OUT	STD_LOGIC; 
          LED_EVENT0	:	OUT	STD_LOGIC; 
          TEST1	:	OUT	STD_LOGIC; 
          TEST2	:	OUT	STD_LOGIC; 
          TEST3	:	OUT	STD_LOGIC; 
          TEST4	:	OUT	STD_LOGIC; 
          GPS_1PPS	:	IN	STD_LOGIC; 
          GPS_TX	:	IN	STD_LOGIC; 
          SPI_CLK	:	IN	STD_LOGIC; 
          SPI_CS	:	IN	STD_LOGIC; 
          SPI_MOSI	:	IN	STD_LOGIC; 
          SPI_MISO	:	OUT	STD_LOGIC);
   END COMPONENT;

   SIGNAL CLK_XTAL	:	STD_LOGIC;
   SIGNAL GPS_1PPS	:	STD_LOGIC;
   SIGNAL GPS_TX	:	STD_LOGIC;
   SIGNAL LED_EVENT1	:	STD_LOGIC;
   SIGNAL LED_EVENT2	:	STD_LOGIC;
   SIGNAL LED_EVENT4	:	STD_LOGIC;
   SIGNAL LED_EVENT3	:	STD_LOGIC;
   SIGNAL LED_EVENT5	:	STD_LOGIC;
   SIGNAL LED_EVENT0	:	STD_LOGIC;
	
	SIGNAL SPI_CLK  : STD_LOGIC;
	SIGNAL SPI_CS   : STD_LOGIC;
	SIGNAL SPI_MISO : STD_LOGIC;
	SIGNAL SPI_MOSI : STD_LOGIC;
	
	SIGNAL TEST1 : STD_LOGIC;
	SIGNAL TEST2 : STD_LOGIC;
	SIGNAL TEST3 : STD_LOGIC;
	SIGNAL TEST4 : STD_LOGIC;	
BEGIN

   UUT: CROCS PORT MAP(
		CLK_XTAL => CLK_XTAL, 
		GPS_1PPS => GPS_1PPS, 
		GPS_TX => GPS_TX, 
		LED_EVENT1 => LED_EVENT1, 
		LED_EVENT2 => LED_EVENT2, 
		LED_EVENT4 => LED_EVENT4, 
		LED_EVENT3 => LED_EVENT3,
		LED_EVENT5 => LED_EVENT5,
		LED_EVENT0 => LED_EVENT0,
		
		SPI_CLK => SPI_CLK,
		SPI_CS => SPI_CS,
		SPI_MISO => SPI_MISO,
		SPI_MOSI => SPI_MOSI,
		
		TEST1 => TEST1,
		TEST2 => TEST2,
		TEST3 => TEST3,
		TEST4 => TEST4
   );

-- *** Test Bench - User Defined Section ***
	clock_gen : process
		begin
			CLK_XTAL <= '0' after clk_half_period, '1' after 2*clk_half_period;
			wait for 2*clk_half_period;
	end process clock_gen;
	
	pps : PROCESS
	BEGIN
		GPS_1PPS <= '0';
		wait for 500ns;
		GPS_1PPS <= '1';
		wait for 200ns;
		GPS_1PPS <= '0';
		wait;
	END PROCESS;
	
	spi : PROCESS
	BEGIN
--		RESET <= '0';
--		wait 50 ns;
--		RESET <= '1';
--		wait 50 ns;
--		RESET <= '0';
--		wait 100 ns;
		wait for 10000 ns;
		--sim_write_msg(X"16", X"00", X"00", X"00", 1000000, SPI_CLK, SPI_CS, SPI_MOSI);
		sim_read_msg(X"16", X"01", 1, 1000000, SPI_CLK, SPI_CS, SPI_MOSI);
		--sim_read_msg(X"16", X"02", 2, 1000000, SPI_CLK, SPI_CS, SPI_MOSI);
		--sim_read_msg(X"16", X"03", 16, 1000000, SPI_CLK, SPI_CS, SPI_MOSI);		
		wait;
	END PROCESS spi;

   tb : PROCESS
   BEGIN
		wait for 100ns;
		
		sim_serial_string("$GPRMC,hhmmss.sss,foo,bar*2D", 10000000, GPS_TX);
		sim_serial_char(CR, 10000000, GPS_TX);
		sim_serial_char(LF, 10000000, GPS_TX);
		
--		sim_serial_string("$GPGGA,1234*7E", 10000000, GPS_TX);
--		sim_serial_char(CR, 10000000, GPS_TX);
--		sim_serial_char(LF, 10000000, GPS_TX);
--
--		sim_serial_string("hjfsdgf", 10000000, GPS_TX);
--		
--		sim_serial_string("$GPZDA,1234*60", 10000000, GPS_TX);
--		sim_serial_char(CR, 10000000, GPS_TX);
--		sim_serial_char(LF, 10000000, GPS_TX);
		wait;
   END PROCESS;
	
-- *** End Test Bench - User Defined Section ***

END;
